package com.gic.haoban.manage.service.service.hm.impl;

import com.gic.haoban.manage.service.dao.mapper.TabHaobanWelcomeTemplateRelationMapper;
import com.gic.haoban.manage.service.entity.hm.TabHaobanWelcomeTemplateRelation;
import com.gic.haoban.manage.service.pojo.bo.hm.HmWelcomeRelationBO;
import com.gic.haoban.manage.service.pojo.qo.WelcomeRelationQO;
import com.gic.haoban.manage.service.service.hm.WelcomeRelationService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author MUSI
 * @Date 2022/7/4 5:50 PM
 * @Description
 * @Version
 **/
@Component
public class WelcomeRelationServiceImpl implements WelcomeRelationService {

    @Autowired
    private TabHaobanWelcomeTemplateRelationMapper welcomeTemplateRelationMapper;

    /**
     * 查询欢迎语关联关系
     *
     * @param referId
     * @param status
     * @return
     */
    @Override
    public HmWelcomeRelationBO queryWelcomeRelation(String referId, Integer status) {
        TabHaobanWelcomeTemplateRelation welcomeTemplateRelation = welcomeTemplateRelationMapper.queryWelTemplateRelation(null, referId, status);
        if (welcomeTemplateRelation == null) {
            return null;
        }
        HmWelcomeRelationBO welcomeRelationBo = new HmWelcomeRelationBO();
        BeanUtils.copyProperties(welcomeTemplateRelation, welcomeRelationBo);
        return welcomeRelationBo;
    }

    /**
     * 条件查询 欢迎语引用列表
     *
     * @param welcomeRelationQo
     * @return
     */
    @Override
    public List<HmWelcomeRelationBO> queryWelcomeRelationList(WelcomeRelationQO welcomeRelationQo) {
        List<TabHaobanWelcomeTemplateRelation> tabHaobanWelcomeTemplateRelations = welcomeTemplateRelationMapper.queryWelcomeTemplate(welcomeRelationQo);
        if (CollectionUtils.isEmpty(tabHaobanWelcomeTemplateRelations)) {
            return Collections.emptyList();
        }
        return tabHaobanWelcomeTemplateRelations.stream()
                .map(item -> {
                    HmWelcomeRelationBO welcomeRelationBo = new HmWelcomeRelationBO();
                    BeanUtils.copyProperties(item, welcomeRelationBo);
                    return welcomeRelationBo;
                }).collect(Collectors.toList());
    }
}
